<template lang="pug">
.fixed.top-0.bottom-0.z-40.w-screen.h-screen.backdrop-blur-md.p-4.flex.flex-col.overflow-hidden
  .bg-base-100.shadow-md.rounded.border.border-neutral.w-full.mx-auto.flex.flex-col.min-h-0(
    class="md:max-w-lg",
    v-click-outside="close"
  )
    header.flex.items-center.justify-between.px-4
      icon.w-5.h-5(name="clarity:search-line")
      input.input.input-ghost.flex-1(
        v-focus,
        v-model="searchText",
        type="text",
        class="focus:outline-none focus:bg-transparent",
        :placeholder="$t('search')"
      )
      .kbd.hidden.cursor-pointer(class="sm:flex sm:kbd-md", @click="$emit('close')") esc
      .btn.btn-ghost.btn-sm(class="sm:hidden", @click="$emit('close')")
        icon.w-5.h-5(name="carbon:close")
    section.border.border-neutral.overflow-hidden.overflow-y-auto.flex-1
      p.p-4.pt-6.font-semibold.border-b.border-neutral {{ $t('articles') }}
      content-list(:query="query", :locale="$i18n.locale")
        template(v-slot="{ list }")
          ul(v-for="article in list", :key="article._path")
            nuxt-link(:to="article._path", @click="$emit('close')")
              li.border-b.border-neutral.p-4.space-y-2.font-light(
                class="hover:bg-base-200 hover:text-primary"
              )
                h1 {{ article.title }}
                .flex.space-x-1.overflow-x-auto
                  span.badge.whitespace-nowrap(
                    v-for="tag in article.tags",
                    :key="tag"
                  ) {{ tag }}
        template(#not-found)
          .text-center.p-4
            i18n-t.font-light(keypath="error.noResultsFor", tag="p")
              template(v-slot:result)
                span.font-bold.whitespace-wrap.break-words {{ searchText }}

    footer.h-12.flex.justify-end
      app-logo
</template>

<script setup lang="ts">
import { computed } from 'vue'
import type { QueryBuilderParams } from '@nuxt/content/dist/runtime/types'

const emit = defineEmits(['close'])
const close = () => emit('close')

const searchText = useDebouncedRef('', 300)

const query: QueryBuilderParams = computed(() => {
  return {
    path: '/',
    where: [
      {
        $or: [
          {
            title: { $regex: `/${searchText.value}/ig` },
          },
          {
            description: { $regex: `/${searchText.value}/ig` },
          },
          {
            category: { $regex: `/${searchText.value}/ig` },
          },
          {
            tags: { $regex: `/${searchText.value}/ig` },
          },
          {
            author: { $regex: `/${searchText.value}/ig` },
          },
        ],
      },
    ],

    sort: [{ createdAt: -1 }],
  }
})
</script>
